/*


*/

import java.util.concurrent.TimeUnit;
import java.util.Optional; // For the return value of get().

/**
   This simulates a first-in-first-out (stack) buffer.
*/
public class Buffer_TimeOut extends Buffer_Bounded
{
   /**
      Create a partially filled bounded buffer.

      @param size          the size of the buffer
      @param currentIndex  initially fill the buffer up to this index
      @param c1  the left bracket for the string representation of the buffer
      @param c2  the char for the filled part of the buffer
      @param c3  the char for the empty part of the buffer
      @param c4  the right bracket for the string representation of the buffer
      @throws IllegalArgumentException if currentIndex is outside of the buffer
   */
   Buffer_TimeOut(final int size, final int currentIndex,
                  final char c1, final char c2, final char c3, final char c4)
   {
      super(size, currentIndex, c1, c2, c3, c4); // Initialize a partially filled buffer.
   }


   public boolean put(final long time, final TimeUnit unit)
   throws InterruptedException
   {
      return put((char)(FILL + random.nextInt(10)), time, unit);
   }


   public Optional<Character> get(final long time, final TimeUnit unit)
   throws InterruptedException
   {
      return get(EMPTY, time, unit);
   }


   /**
      Try to insert the given character at the next available buffer location.

      Every time we do a successful operation on this buffer, it prints out its state.

      @param c     character to put in the buffer
      @param time  amount of time to wait for a free space in this buffer
      @param unit  the {@link TimeUnit} of time to use in the wait
      @return true if the char c was placed in the buffer, false if the buffer timed out
   */
   public boolean put(final char c, final long time, final TimeUnit unit)
   throws InterruptedException
   {






   }


   /**
      Try to remove from the buffer the character at the buffer's current index.
      Mark the newly emptied spot in the buffer with the given character.
      Return, in an Optional object, the character that was removed from the buffer.
      If the buffer times out, return an "empty" Optional object.

      Every time we do a successful operation on this buffer, it prints out its state.

      @param c     character to use to mark the newly emptied position in the buffer
      @param time  amount of time to wait for an item from this buffer
      @param unit  the {@link TimeUnit} of time to use in the wait
      @return an {link Optional} holding the character removed from the buffer
   */
   public Optional<Character> get(final char c, final long time, final TimeUnit unit)
   throws InterruptedException
   {






   }
}
