/*


*/

import java.util.concurrent.TimeUnit;
import java.util.Random;
import java.util.Optional; // For the return value of the non-blocking getNB().

/**
   Each time that a consumer should consume an item, it
   randomly chooses a non-blocking buffer to get an item
   from. If that buffer's non-blocking getNB() method fails,
   then the consumer will randomly choose another buffer.
*/
class Consumer_v2 implements Runnable
{
   private final Buffer_NoBlock[] bufs;
   private int ms;
   private final Random random = new Random();

   /**
      Create a consumer that uses the given array of non-blocking buffers.

      Each time the consumer wants to consume an item the consumer will
      randomly choose a buffer from the array of non-blocking buffers
      and call that buffer's non-blocking getNB() method. If that buffer's
      non-blocking getNB() method fails (because the buffer is empty), then
      the consumer will randomly choose another non-blocking buffer from
      the array.

      After successfully getting an item from a buffer, the consumer should
      sleep for the given number of milliseconds.

      @param bufs   array of {@link Buffer_NoBlock} objects
      @param ms     milliseconds of delay after consuming one item
   */
   public Consumer_v2(final Buffer_NoBlock[] bufs, final int ms)
   {
      this.bufs = bufs;
      this.ms = ms;
   }


   @Override
   public void run()
   {
      try
      {
         while (! Thread.currentThread().isInterrupted())
         {




         }
      }
      catch (InterruptedException e)
      {
         // Print a stack trace and then the thread dies.
         e.printStackTrace();
      }
   }
}
