/*


*/

import java.util.concurrent.TimeUnit;
import java.util.Random;
import java.util.Optional; // For the return value of the timed get().

/**
   Each time that a consumer should consume an item,
   it randomly chooses a timed buffer to get an item
   from. If that buffer's timed get() method times out,
   then the consumer will randomly choose another buffer.
*/
class Consumer_v3 implements Runnable
{
   private final Buffer_TimeOut[] bufs;
   private int ms;
   private final Random random = new Random();

   /**
      Create a consumer that uses the given array of timed buffers.

      Each time the consumer wants to consume an item the consumer will
      randomly choose a buffer from the array of timed buffers and call
      that buffer's timed version of the get() method. If that buffer's
      timed get() method times out, then the consumer will randomly
      choose another timed buffer from the array.

      After successfully getting an item from a buffer, the consumer
      should sleep for the given number of milliseconds.

      @param bufs  array of {@link Buffer_TimeOut} objects
      @param ms    milliseconds of delay after consuming one item
   */
   public Consumer_v3(final Buffer_TimeOut[] bufs, final int ms)
   {
      this.bufs = bufs;
      this.ms = ms;
   }


   @Override
   public void run()
   {
      try
      {




      }
      catch (InterruptedException e)
      {
         // Print a stack trace and then the thread dies.
         e.printStackTrace();
      }
   }
}
