/*


*/

import java.util.concurrent.locks.Lock;
import java.util.Random;

/**
   Each time that a producer should produce an item, it
   randomly chooses a non-blocking buffer to put an item
   into. If that buffer's non-blocking putNB() method fails,
   then the consumer will randomly choose another buffer.
*/
class Producer_v2 implements Runnable
{
   private final Buffer_NoBlock[] bufs;
   private int ms;
   private final Random random = new Random();

   /**
      Create a producer that uses the given array of non-blocking buffers.

      Each time the producer wants to produce an item the producer will
      randomly choose a buffer from the array of non-blocking buffers
      and call that buffer's non-blocking putNB() method. If that buffer's
      non-blocking putNB() method fails (because the buffer is full), then
      the consumer will randomly choose another non-blocking buffer from
      the array.

      After successfully putting an item into a buffer, the producer should
      sleep for the given number of milliseconds.

      @param bufs   array of {@link Buffer_NoBlock} objects
      @param ms     milliseconds of delay after producing one item
   */
   public Producer_v2(final Buffer_NoBlock[] bufs, final int ms)
   {
      this.bufs = bufs;
      this.ms = ms;
   }


   @Override
   public void run()
   {
      try
      {
         while (! Thread.currentThread().isInterrupted())
         {




         }
      }
      catch (InterruptedException e)
      {
         // Print a stack trace and then the thread dies.
         e.printStackTrace();
      }
   }
}
