/*

*/

import java.util.concurrent.TimeUnit;
import java.util.Random;

/**
   Each time that a producer should produce an item,
   it randomly chooses a timed buffer to put the item
   into. If that buffer's timed put() method times out,
   then the producer will randomly choose another buffer.
*/
class Producer_v3 implements Runnable
{
   private final Buffer_TimeOut[] bufs;
   private int ms;
   private final Random random = new Random();

   /**
      Create a producer that uses the given array of timed buffers.

      Each time the producer wants to produce an item the producer will
      randomly choose a buffer from the array of timed buffers and call
      that buffer's timed version of the put() method. If that buffer's
      timed put() method times out, then the producer will randomly
      choose another timed buffer from the array.

      After successfully putting an item into a buffer, the producer
      should sleep for the given number of milliseconds.

      @param bufs  array of {@link Buffer_TimeOut} objects
      @param ms    milliseconds of delay after producing one item
   */
   public Producer_v3(final Buffer_TimeOut[] bufs, final int ms)
   {
      this.bufs = bufs;
      this.ms = ms;
   }


   @Override
   public void run()
   {
      try
      {




      }
      catch (InterruptedException e)
      {
         // Print a stack trace and then the thread dies.
         e.printStackTrace();
      }
   }
}
