/*
   Do not modify this file.
*/

import static java.util.concurrent.TimeUnit.SECONDS;

/**
   Use the Buffer_TimeOut class for the buffers.
   The producers and consumers can then back off
   from buffers that are full or empty.
*/
public class ProducersConsumers_v3
{
   public static void main(String[] args) throws InterruptedException
   {
      final int size = 16;
      final Buffer_TimeOut[] bufs = {
                new Buffer_TimeOut(size, size/2, '[', '0', '_', ']'), // half full
                new Buffer_TimeOut(size, size/2, '{', 'a', '=', '}'),
                new Buffer_TimeOut(size, size/2, '<', 'A', '-', '>')
                            };

      final Runnable producer1 = new Producer_v3(bufs, 30);
      final Runnable producer2 = new Producer_v3(bufs, 30);
      final Runnable consumer1 = new Consumer_v3(bufs, 15);

      final Thread t1 = new Thread(producer1);
      final Thread t2 = new Thread(producer2);
      final Thread t3 = new Thread(consumer1);

      System.out.println(bufs[0]);
      System.out.println(bufs[1]);
      System.out.println(bufs[2]);

      t1.start();
      t2.start();
      t3.start();

      SECONDS.sleep(60);  // 60 seconds
    //SECONDS.sleep(300); // 5 minutes

      t1.interrupt();
      t2.interrupt();
      t3.interrupt();

      t1.join(); System.out.println("t1 done");
      t2.join(); System.out.println("t2 done");
      t3.join(); System.out.println("t3 done");

      System.out.println("All threads done.");
   }
}
